--- a/arch/mips/ralink/irq-gic.c
+++ b/arch/mips/ralink/irq-gic.c
@@ -13,6 +13,12 @@
 
 int get_c0_perfcount_int(void)
 {
+	/*
+	 * Performance counter events are routed through GIC.
+	 * Prevent them from firing on CPU IRQ7 as well
+	 */
+	clear_c0_status(IE_SW0 << 7);
+
 	return gic_get_c0_perfcount_int();
 }
 EXPORT_SYMBOL_GPL(get_c0_perfcount_int);
